#include "web_server.h"

#include <string.h>
#include <signal.h>
#include <stdlib.h>
#include <math.h>

#include "info.h"
#include "engine.h"
#include "functions.h"
#include "examples.h"
#include "security.h"


#ifdef WIN32
#include <windows.h>
#endif


int PORT=80;



void startpage(char *topic) {
	printf("Content-type: text/html\r\n\r\n");
	printf("<HTML>\n<body bgcolor='EFEFFF'>\n<CENTER>\n<TABLE><TR><TD align=center>\n<a href='libwebserver.sourceforge.net'><img border=0 src='/libwebserver.gif'></a>\n</TD><TR><TR><TD align=center>\n<font face='Verdana'><B>HELP<BR>(%s)</B></font>\n</TD></TR></TABLE>\n</CENTER>\n<HR><BR>\n",topic);
};
void endpage() {
	printf("<HR><p align=right> <small> by Luis Figueiredo (<a href='mailto:stdio@netc.pt'>stdio@netc.pt</a>) (%s)</BODY></HTML>\n",_libwebserver_version);
};

void logfile() {
	startpage("logfile");
	printf("<PRE>\n");
	web_client_addfile("help.log");
	printf("</PRE>\n");
	endpage();
};

struct image {
	char *data;
	size_t size;
} image={NULL,0};

void imageout() {
	if(strlen(ClientInfo->Query("img"))) {
		if(image.data!=NULL) {
			printf("Content-type: image/jpeg\r\n\r\n");
			fwrite(image.data,image.size,1,stdout);
		};
		return;
	};
	startpage("Image example");
	printf("<form action='/image' method='POST' enctype='multipart/form-data'>\n");
	printf("<input type=file name=image><BR>\n");
	printf("<input type=submit name='GOO' value='See'>\n");
	printf("</form>\n");
	if(strlen(ClientInfo->MultiPart("image").data)) {
		printf("%s<BR><img src='/image?img=%s.jpg'>\n",ClientInfo->MultiPart("image").filename,ClientInfo->MultiPart("image").filename);
		free(image.data);
		image.data=malloc(ClientInfo->MultiPart("image").size+1);
		memcpy(image.data,ClientInfo->MultiPart("image").data,ClientInfo->MultiPart("image").size);
		image.size=ClientInfo->MultiPart("image").size;
	}else {
		free(image.data);
		image.data=NULL;
	};
	endpage();
};
#define GIFSIDE 320
char gifdata[GIFSIDE*GIFSIDE];
void outgif() {
	float i;
	int x,y,xc,yc;
	int color;
	if(*ClientInfo->Query("img")!=0) {
		printf("Content-type: image/gif\r\n\r\n");
		if(!strcmp(ClientInfo->Query("img"),"circle")) {
			xc=atoi(ClientInfo->Query("x"))%GIFSIDE;
			yc=atoi(ClientInfo->Query("y"))%GIFSIDE;
			color=(rand()%15)+1;
			for(i=0;i<6.28;i+=(float)0.01) {
				x=(int)((xc+cos(i)*10))%GIFSIDE;
				y=(int)((yc+sin(i)*10))%GIFSIDE;
				gifdata[x+(y*GIFSIDE)]=color;
			};
		};
		web_client_outputgif(gifdata,GIFSIDE,GIFSIDE);
	};
	startpage("Gif example");
	printf("<center>Generated a circle (click inside the image)<BR>\n");
	printf("Pressed x=%s,y=%s<BR>\n",ClientInfo->Query("x"),ClientInfo->Query("y"));
	printf("<form><input type=image border=0 src='/gif?img=circle&x=%s&y=%s'></form></CENTER>\n",ClientInfo->Query("x"),ClientInfo->Query("y"));
	endpage();
};


void urlauthenticate() {
        if(!strlen(ClientInfo->user) || !strlen(ClientInfo->pass) &&
            strcmp(ClientInfo->user,"username") || strcmp(ClientInfo->pass,"password")) { // you can read things from a auth file
                web_client_HTTPdirective("HTTP/1.1 401 Authorization Required");
                printf("WWW-Authenticate: Basic realm=\"This site info\"\r\n");
		startpage("Authenticate example");
                printf("<CENTER><font color='FF0000'>Access denied</font></CENTER>\n");
		endpage();
                return;
        }
	startpage("Authenticate example");
        printf("You entered in your area\n");
	endpage();
};


void help() {
	// info
	// engine
	// functions help
	// functionall examples
	// security
	// regards
	// authors
	if(!strlen(ClientInfo->Query("help"))) {	
		startpage("Table of contents");
		printf("<B>\n");
		printf("<ol>\n");
		printf("<li><a href='/?help=info'>libwebserver info</a></li>\n");
		printf("<ul><li><a href='/?help=info#what'>What's libwebserver for?</a></li></ul>\n");
		printf("<ul><li><a href='/?help=info#who'>Who's suposed to use libwebserver?</a></li></ul>\n");
		printf("<ul><li><a href='/?help=info#when'>When i'm suposed to use libwebserver?</a></li></ul>\n");
		printf("<ul><li><a href='/?help=info#server_scripts'>It suport server scripts such as .php .cgi .asp?</a></li></ul>\n");
		printf("<li><a href='/?help=engine'>libwebserver engine</a></li>\n");
		printf("<ul><li><a href='/?help=engine#how'>How it works?</a></li></ul>\n");
		printf("<ul><li><a href='/?help=engine#modules'>Modules description</a></li></ul>\n");
		printf("<ul><li><a href='/?help=engine#structures'>internal data structures</a></li></ul>\n");
		printf("<li><a href='/?help=functions'>libwebserver functions</a></li>\n");	
		printf("<ul><li><a href='/?help=functions#web_server_init'>web_server_init()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_server_addhandler'>web_server_addhandler()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_server_run'>web_server_run()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_server_useSSLcert'>web_server_useSSLcert()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_client_addstream'>web_client_addstream()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_client_addfile'>web_client_addfile()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_client_outputgif'>web_client_outputgif()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_client_HTTPdirective'>web_client_HTTPdirective()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#web_log'>web_log()</a></li></ul>\n");	
		printf("<ul><li><a href='/?help=functions#ClientInfo'>ClientInfo</a></li></ul>\n");	
		printf("<li><a href='/?help=examples'>libwebserver examples</a></li>\n");
		printf("<ul><li><a href='/?help=examples#logfile'>Show's log file</a></li></ul>\n");
		printf("<ul><li><a href='/?help=examples#imageup'>Image Uploader</a></li></ul>\n");
		printf("<ul><li><a href='/?help=examples#auth'>Authentication</a></li></ul>\n");
		printf("<ul><li><a href='/?help=examples#ssl'>Openssl for (https)</a></li></ul>\n");
		printf("<ul><li><a href='/?help=examples#outgif'>Gif generator</a></li></ul>\n");
		printf("<ul><li><a href='/brokenlink'>Broken link</a></li></ul>\n");
		printf("<li><a href='/?help=security'>libwebserver security</a></li>\n");
		printf("<ul><li><a href='/?help=security#safe'>Its safe to use?</a></li></ul>\n");
		printf("<li><a href='/?help=Authors'>Authors</a></li>\n");
		printf("</ol>\n");
		printf("</B>\n");
		endpage();	
		return;	
	};

	startpage(ClientInfo->Query("help"));
	if(!strcmp(ClientInfo->Query("help"),"info")) {
		fwrite(info,sizeof(info),1,stdout);
		//web_client_addfile("help.html/info.html");
	};
	if(!strcmp(ClientInfo->Query("help"),"engine")) {
		fwrite(engine,sizeof(engine),1,stdout);
		//web_client_addfile("help.html/engine.html");
	};
	if(!strcmp(ClientInfo->Query("help"),"security")) {
		fwrite(security,sizeof(security),1,stdout);
		//web_client_addfile("help.html/security.html");
	};
	if(!strcmp(ClientInfo->Query("help"),"functions")) {
		fwrite(functions,sizeof(functions),1,stdout);
		//web_client_addfile("help.html/functions.html");
	};
	if(!strcmp(ClientInfo->Query("help"),"examples")) {
		fwrite(examples,sizeof(examples),1,stdout);
		//web_client_addfile("help.html/examples.html");
	};
	if(!strcmp(ClientInfo->Query("help"),"Authors")) {
		printf("Luis Figueiredo (<a href='mailto:stdio@netc.pt'>stdio@netc.pt</a>) - Main programmer, designer<BR><BR>\n");
	};
	endpage();	
};



int main() {
	struct web_server server;
#ifdef DEBUG	
	FILE *err=fopen("debug.log","w");
	*stderr=*err;
#endif // DEBUG

	
	memset(gifdata,0,GIFSIDE*GIFSIDE);
	while(!web_server_init(&server,PORT,"help.log",0))PORT++;
	web_server_addhandler(&server,"* /",help,0);
	web_server_addhandler(&server,"* /log",logfile,0);
	web_server_addhandler(&server,"* /image",imageout,0);
	web_server_addhandler(&server,"* /gif",outgif,0);
	web_server_addhandler(&server,"* /auth",urlauthenticate,0);
	printf("http://localhost:%d\n",PORT);
	
	while(1) {
		web_server_run(&server);
	};


};
